﻿Imports System.Data.SqlClient
Imports System.Data.Linq

Public Class Form1
    Private dc As New LINQtoSQLDataContext

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim connectionStr As String
        Dim cn As SqlConnection
        Dim cmd As SqlCommand
        Dim dr As SqlDataReader

        ' Connection String untuk connection kedalam Database Nortwind
        connectionStr = "Data Source=localhost;Initial Catalog=Northwind;Integrated Security=True"
        cn = New SqlConnection(connectionStr)
        cn.Open()

        ' Query data Customer yang ada dalam database Nortwind 
        cmd = New SqlCommand("Select * from Customers where Country='Germany'", cn)
        dr = cmd.ExecuteReader


        ' Proses LINQ membaca DataReader yang telah dibuat sebelumnya
        Dim LINQ = From cust In dr _
                   Select ID = cust.item("CustomerID"), Name = cust.item("CompanyName")

        ' Menampilkan data hasil query kedalam messagebox
        Dim hasil = "-- Data customer dari Jerman -- " & vbCrLf
        For Each cust In LINQ
            hasil = hasil & cust.ID & " - " & cust.Name & vbCrLf
        Next

        MsgBox(hasil)
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click

        Dim LINQ = From cust In dc.Customers _
                   Order By cust.CompanyName _
                   Where cust.Country.ToLower = "germany" _
                   Select cust

        Dim hasil = "-- Data Customer Northwind --" & vbCrLf
        For Each cust In LINQ
            hasil = hasil & cust.CompanyName & vbCrLf
        Next

        MsgBox(hasil)
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        '---- Membuat object DataContext ------
        Dim connectionStr = "Data Source=localhost;" & _
          "Initial Catalog=Northwind;" & _
          "Integrated Security=True"
        Dim Db = New DataContext(connectionStr)

        '---- Membaca table CUSTOMERS kedalam class Customer  ------
        Dim Customers As Table(Of Customer) = Db.GetTable(Of Customer)()

        '---- Melakukan query kedalam class customers table ------
        Dim Query = From cust In Customers _
                    Where cust.Country = "germany" _
                    Select cust

        '---- Membaca data hasil query LINQ  ------
        Dim hasil = "-- Data customer dari Jerman -- " & vbCrLf
        For Each cust In Query
            hasil = hasil & cust.CustomerID & "-" & cust.Country & vbCrLf
        Next
        MsgBox(hasil)
    End Sub


End Class
